% This m-file reads the .txt files containing the personas and stores them as .mat files

clear all;close all;clc
read_personas_from_txt = 0;
P = NaN(15,2000);
if read_personas_from_txt ==1
    for p=1:15 % loop over 15 persona types
        t=fileread(['store_all_personas' num2str(p)]); % read .txt file
        id=strfind(t,'nothing else');
        t=t(id:end);
        nl = strfind(t,newline);
        space = strfind(t,' ');
        for i=1:2000 % loop over 2000 personas
            if ismember(p,10)
                si=strfind(t,[sprintf('%0.4d',i) ')']);
            elseif ismember(p,12)
                si=strfind(t,[sprintf('%0.4d',i) ':']);
            else
                si=strfind(t,[sprintf('%0.4d',i) '.']);
            end
            P(p,i)=length(si);
            if P(p,i)~=1 % make sure that each persona, from 1 to 2000 is represented exactly once; if not, pause the loop
                pause
            end
            ei=nl(find(nl>si,1,'first')); % first end of line index
            bi=space(find(space>si,1,'first')); % first end of line index
            Persona{p,i} = t(bi+1:ei-1);
        end
    end
    save('Personas.mat','Persona')
end

load Personas
%% Here we extract the age and gender from each persona
clc
Age = NaN(15,2000);
Gender = zeros(15,2000);
for p=1:15 % loop over 15 persona types
    for i=1:2000 % loop over 2000 personas
        persona = Persona{p,i};
        if p==1
            Age(p,i)=str2double(persona(1:3));
        else
            comma = strfind(persona,',');
            age = regexp(persona, '\d{1,3}', 'match');
            if ~isempty(age)
                Age(p,i) = str2double(age(1));
            else
                Age(p,i)=NaN; % ageless, unknown age
            end
        end
        if contains(lower(persona),', male,') || contains(lower(persona),', man,')
            Gender(p,i) = Gender(p,i) + 2;
        elseif contains(lower(persona),', female,') || contains(lower(persona),' feminine,') || contains(lower(persona),' woman,')
            Gender(p,i) = Gender(p,i) + 1;
        else
            if contains(lower(persona),' male,') || contains(lower(persona),' males,')
                Gender(p,i) = Gender(p,i) + 2;
            elseif contains(lower(persona),' female') || contains(lower(persona),' female,') || contains(lower(persona),' she ')
                Gender(p,i) = Gender(p,i) + 1;
            else
                Gender(p,i) = NaN;
            end
        end
    end
end
save('Personas_with_age_and_gender.mat','Persona','Age','Gender')
